Subject: Response to IBM ADC comments

From: "Hildebrand, Jeff" <[email-masked]>
Date: Tue, 26 Apr 94 04:28:00 PDT

My responses after >
Jeff

In my view, the primary requirement for ADC is:

   "allowing the programs to exchange data in any high-level construct,
    such as array and record data types, and at the same time, to
    preserve their meaning."

Since CPI-C supports three kinds of application data, namely,
   - normal data
   - expedited data
   - initialization data
I believe they all require ADC support.
>
> I recall Expedited data being ruled out by the CIW.
>

In principle, CPI-C 2.0 works on both the LU 6.2 and OSI TP CRMs.
This applies to ADC as well.

In Jeff's list of the requirements,
  - I agree to the first part of (4) that the existing program should
    continue to run, but I disagree to the statement of "allow existing
    programs to use these new facilities without modifying existing code."
    If this were true, no change would be required to the interface.
    Then neither Set/Extract (from Boeing) nor Send/Receive
    (from Attachmate) could meet this requirement.  This seems to me
    a precondition for a certain solution that hasn't been discussed
    by the SIG.

>
>You missed the point.  Side information can carry the information
>necessary to allow existing programs to use new capabilities without 
modification to their
>source code.  Backwards compatibility has always been a major concern.
>

  - I believe (5) (6) (7) and (8) are not requirement statements
    because they are concerned with a particular solution or
    development process.

>
> I must disagree strenuously,
> # 5 is straight out of the CIW .  I was made very clear that there
> was little support for additional send and receive verbs, and that 
creating
> new verbs would seriously hurt backwards compatibility.
>
>#6 One of the purposes of CPIC is to shelter programmers from
>the complexity of the network..  The encoding and decoding of data
>will likely be very complex and should be performed by specialists
> who shelter other programmers.  Why, would a company want to train
> everyone to build these modules, when a small group of people could
>service everyone?
>
>#7 This is a paramount goal of ADC.  The application programmer
>should use, essentially, a library function which would be a black
>box..
>#8. I do not under stand your objection, this is rather obvious.
>

  - I disagree to (9) that all pointers must be resolved.  Pointer
    is a type of application data, and NIDL (both in Apollo NCS and
    in DCE RPC) supports the pointer type.  I think the requirement
    should be to allow the use of data description languages such as
    ASN.1 and NIDL.
>
>I believe that we had decided  pointers must be resolved at the last
>CIW
>

Chung-Huy Chen